<?php
/**
*
* @Ucoz2phpBB
* @version $Id: ucoz2bb.php,v 0.9 2011/01/09 $
* @copyright (c) 2010 Dudarik
* @copyright (c) 2010 FryPpy
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

//Заголовки для отключения кеширования в браузере    
header("Expires: Tue, 1 Jul 2010 05:00:00 GMT");      
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");  
header("Cache-Control: no-store, no-cache, must-revalidate");  
header("Pragma: no-cache");  
header('Content-Type: text/html;charset=utf-8');

// Увеличиваем максимальное время выполнение скрипта  
set_time_limit(6000);  
  
// Весь вывод сразу будет отсылаться в браузер  
ob_implicit_flush();  
// Не тут то было - в многоуровневом пироге каждый пытается создать свой буффер 
// и подождать с отсылкой данных
// Так что придется жестко прочищать эти буффера отсылая ~25Кб пустоты
// Надеюсь этот скрипт будет запускаться не часто
// НА САМОМ ДЕЛЕ САМЫМ МЕДЛЕННЫМ ЯВЛЯЕТСЯ ИМПОРТ ПОЛЬЗОВАТЕЛЬСКИХ АВАТАР!!! 
function my_flush()
{
	echo str_pad(' ', 25000);
}
?>
<!DOCTYPE HTML>

<HTML>
<HEAD>
 <META http-equiv=content-type content="text/html; charset=utf-8"> 
 <TITLE>Импорт форума UCOZ в PHPbb</TITLE>
</HEAD>
<BODY bgcolor=#FFFFFF text=#000000 link=#000099 vlink=#330066 alink=#FF0000 marginwidth=0 marginheight=0 leftmargin=0 topmargin=0>
<H2>
Импорт дампа форума ucoz в PHPbb. 
</H2>
Процесс импорта может занять продолжительное время.<br/>
Во время импорта будут выводиться информационные сообщения свидетельствующие о прогрессе импорта.<br/>
Не разрывайте соединение с этим узлом пока процесс импорта не завершится, о чем будет выдано соответствующее сообщение.
<P>
Прогресс импорта форума: <br/>
<?php
 	define('IN_PHPBB', true);

    global $phpbb_root_path;
    global $phpEx;
    global $db;
    global $config;
    global $user;
    global $auth;
    global $cache;
    global $template;
    global $groups_map;
    global $ucoz_uid_shift;
    global $ucoz2PHPbb_UID_map;
    global $acl_map;
    global $topics_with_pools;
	global $max_avatar_size;
	global $max_avatar_width;
	global $max_avatar_height;
	global $min_avatar_width;
	global $min_avatar_height;
	
    $phpEx = substr(strrchr(__FILE__, '.'), 1);
    $phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';

	define ("DEBUG",1);
	define ("FORUM_CAT",0);
	define ("FORUM_POST",1);
	define ("ITEM_UNLOCKED",0);

    require_once($phpbb_root_path ."common.php");
    require_once($phpbb_root_path ."config.php");
    require_once($phpbb_root_path ."includes/functions_user.php");
    require_once($phpbb_root_path ."includes/functions.php");
    require_once($phpbb_root_path ."includes/db/db_tools.php");
    require_once($phpbb_root_path ."includes/utf/utf_tools.php");
    require_once($phpbb_root_path ."includes/constants.php");
    
// экранирование ввода пользователя перед отправкой в БД
// FIXME: Надо проработать для различных СУБД
function _E($str)
{
//	global $db;
	
//	return $db->sql_escape($str);
	return preg_replace('/\'/', '\\\'', $str);
}

/// Преобразовать тело сообщения, убрав все лишнее 
/// TODO:  вот тут надо поработать
function convert_post($str)
{
//	return _E(str_replace('<p>', '<br /><br />',$str));
//  Такое ощущение что не стоило тут применять экранирование вовсе (иначе отваливаются ссылки и смайлы)
//	но что-то подсказывает иначе будет хуже - неэкранированные ковычки просто разорвут строковые константы в запросах
//	Возможно стоит вернуться к версии с заменой только одинарных кавычек (хотя она станет СУБД ЗАВИСИМОЙ!!!)
	return _E(str_replace('<p>', '<br /><br />',$str));
}
    
function analyze_phpbb()
{   
	global $db, $ucoz_uid_shift, $ucoz_fid_shift, $ucoz_tid_shift, $ucoz_pid_shift, $max_avatar_size, $max_avatar_width, $max_avatar_height, $min_avatar_width, $min_avatar_height;
	
	// TODO: извлечь эти параметры аватар из базы данных
	$max_avatar_size = 6144;
	$max_avatar_width= 90;
	$max_avatar_height = 90;
	$min_avatar_width = 20;
	$min_avatar_height = 20;
	
	echo 'Анализ состояния форума PHPbb...	';

	$_result = $db->sql_query('SELECT MAX(user_id) AS MaxUID FROM ' . USERS_TABLE .  ';');
	$ucoz_uid_shift = $db->sql_fetchfield('MaxUID');
	if($ucoz_uid_shift === false)
		$ucoz_uid_shift = 60;
	$db->sql_freeresult($_result);
	 
	$_result = $db->sql_query('SELECT MAX(forum_id) AS MaxFID FROM ' . FORUMS_TABLE .  ';');
	$ucoz_fid_shift = $db->sql_fetchfield('MaxFID');
	if($ucoz_fid_shift === false)
		$ucoz_fid_shift = 0;
	$db->sql_freeresult($_result);

	$_result = $db->sql_query('SELECT MAX(topic_id) AS MaxTID FROM ' . TOPICS_TABLE .  ';');
	$ucoz_tid_shift = $db->sql_fetchfield('MaxTID');
	if($ucoz_tid_shift === false)
		$ucoz_tid_shift = 0;
	$db->sql_freeresult($_result);

	$_result = $db->sql_query('SELECT MAX(post_id) AS MaxPID FROM ' . POSTS_TABLE .  ';');
	$ucoz_pid_shift = $db->sql_fetchfield('MaxPID');
	if($ucoz_pid_shift === false)
		$ucoz_pid_shift = 0;
	$db->sql_freeresult($_result);
	
	echo '(ГОТОВО). <br/>';
	echo 'В форуме PHPbb зарегистрировано:<br/>&nbsp; пользователей: ' . $ucoz_uid_shift .
		'<br/>&nbsp; форумов: ' .$ucoz_fid_shift .
		'<br/>&nbsp; топиков: ' . $ucoz_tid_shift .
		'<br/>&nbsp; постов: ' . $ucoz_pid_shift . '<br/>';
}
				 	 
// Карта ACL для основных групп 
// FIXME! Необходимо получить индексы из таблиц _groups и _acl_roles
$forum_acl_map = array(
				 array(7 => 24), // NEWLY_REGISTERED -> FORUM_NEW_MEMBER
				 array(6 => 19), // BOTS -> FORUM_BOT
				 array(5 => 10), // ADMINS -> FORUM_FULL + MOD_FULL
				 array(5 => 14), 
				 array(4 => 21), // MODERATORS -> FORUM_POOLS
				 array(3 => 15), // COPA REGISTERED -> FORUM_STANDARD
				 array(2 => 15), // REGISTERED -> FORUM_STANDARD
				 array(1 => 17), // GUESTS -> FORUM_READONLY
				);
$cat_acl_map = array(
				 //array(7 => 17), // NEWLY_REGISTERED -> FORUM_READONLY
				 array(6 => 17), // BOTS -> FORUM_READONLY
				 /*array(5 => 14), // ADMINS -> FORUM_FULL + MOD_FULL
				 array(5 => 10), */
				 array(3 => 17), // COPPA REGISTERED -> FORUM_READONLY
				 array(2 => 17), // REGISTERED -> FORUM_READONLY
				 array(1 => 17), // GUESTS -> FORUM_READONLY
				);	
					
					
/// Создать ACL для основных групп к форуму/категории
function add_acl_to_forum($forum_id, $is_forum = false)
{
	global $db, $cat_acl_map, $forum_acl_map;
	
	$map = $cat_acl_map;
	if($is_forum)
		$map = $forum_acl_map;
		
	for($i = 0; $i < count($map); ++$i)
		foreach($map[$i] as $group_id => $role_id)
		{
			$group_acl = array(
								'group_id'			=> $group_id,
								'forum_id'			=> $forum_id,
								'auth_option_id'	=> 0,
								'auth_role_id'		=> $role_id,
								'auth_setting'		=> 0,
								);
			$sql = 'INSERT INTO ' . ACL_GROUPS_TABLE . ' ' . $db->sql_build_array('INSERT', $group_acl);
			$db->sql_query($sql);
		}
}	

$ucoz2PHPbb_UID_map = array( );
// Карта соответствий UIDов из ucoz в UIDы PHPbb - заполняется в ucoz_import_users
// TODO: реализовать дефрагментацию при добавлении пользователей

define ("USER_FOR_ABANDOONED_TOPICS", 2);
define ("USER_FOR_ABANDOONED_POSTS", 1);
	
// Получить UID в PHPbb
// Если нет такого ucoz UID - то вернется результат в зависимости от $for_topic
// $for_topic (UID будет использоваться как UID создателя темы)
// $for_topic = true -> USER_FOR_ABANDOONED_TOPICS (АДМИН)
// $for_topic = false -> USER_FOR_ABANDOONED_POSTS (АНОНИМ)
function get_PHPbb_uid($ucoz_uid, $for_topic = false)
{
	global $ucoz2PHPbb_UID_map;
	
	$uid = trim($ucoz_uid);
	if($uid == '')
		return 0;
	
	if(array_key_exists($uid, $ucoz2PHPbb_UID_map))
		return $ucoz2PHPbb_UID_map[$uid];
	
	if($for_topic)
		return USER_FOR_ABANDOONED_TOPICS;
	return USER_FOR_ABANDOONED_POSTS;
}

/// Добавить дополнительные поля профиля пользователя
function ucoz_add_user_profile($user_id, $r_user, $r_ugen)
{
	global $db;
	return;
	
	$user_profile = array(
						'user_id'		=> $user_id,
						'pf_name'		=> _E($r_user[5]),
						);
	// Пол: 1-мужской, 2-женский
	$user_profile['pf_gender'] = 1;
	if($r_user[6])
	{
		if($r_user[6] == 1)
			$user_profile['pf_gender'] = 2; 
		elseif($r_user[6] == 2)
			$user_profile['pf_gender'] = 3; 
	}
					
	$sql = 'INSERT INTO ' . PROFILE_FIELDS_DATA_TABLE . ' ' . $db->sql_build_array('INSERT', $user_profile);
	$db->sql_query($sql);
}

define ("DUMP_AVATARS_PATH", 'avatar');

// Добавить аватар пользователю, загрузив его с URL УОЗА
// Не всегда УКОЗ отдает аватары, (у меня не отдает аватары внедренные в мой форум)
// поэтому попробуем найти подходящий аватар в папке avatars из дампа
// если и это не удастся, то в таких случаях используется метод "Внешняя ссылка" 
// После сохранения аватара - если надо, то поправляется его размер
// Существует функция PHPbb - avatar_upload($data, &$error) - но с УКОЗом не все чисто)
function ucoz_add_avatar($avatar_url, $user_id, &$user_sql)
{
	global $config, $phpbb_root_path;
		
///Код из PHPbb /download/file.php
	$prefix = $config['avatar_salt'] . '_';
	$image_dir = $config['avatar_path'];
	
/*	нахуй нужны эти проверки? (в таблице phpbb_config прописано avatar_path = images/avatars/upload)
	if(substr($image_dir, -1, 1) == '/' || substr($image_dir, -1, 1) == '\\')  //зачем нужно первое сравнение?
	{
		$image_dir = substr($image_dir, 0, -1) . '/';
	}
	$image_dir = str_replace(array('../', '..\\', './', '.\\'), '', $image_dir);

	if($image_dir && ($image_dir[0] == '/' || $image_dir[0] == '\\'))
	{
		$image_dir = '';
	}  
*/
///

	$ext = substr(strrchr($avatar_url, '.'), 1); // расширение файла аватара
	$ava_filenmae = $user_id . '.' . $ext;	// строка вида: 89.gif	
	$ava_filenmae_sql = $user_id . '_' . time() . '.' . $ext; // строка вида: 89_1347561562.gif
	$ava_full_path = $phpbb_root_path . $image_dir . '/' . $prefix .  $ava_filenmae; // строка вида: ./images/avatars/upload/5161b167a35e35e4defe99623df6dc2e_89.gif
	
	
	// Попробуем найти аватар из дампа
	$avatar_url_aray = explode('/', $avatar_url);
	$avatar_filename = DUMP_AVATARS_PATH . "/" . 
		$avatar_url_aray[count($avatar_url_aray) - 2] . "/" . 
		$avatar_url_aray[count($avatar_url_aray) - 1];
	if(file_exists($avatar_filename))
		if(copy($avatar_filename, $ava_full_path) )
		{
			$user_sql['user_avatar'] = $ava_filenmae_sql; // замена $ava_filenmae
			$user_sql['user_avatar_type'] = AVATAR_UPLOAD;
			//$user_sql['user_avatar_width'] = $config['avatar_max_width']; - перенесено в postprocess_avatar()
			//$user_sql['user_avatar_height']	= $config['avatar_max_width']; - перенесено в postprocess_avatar()
			postprocess_avatar($ava_full_path, $user_sql);			
			return;
		}	
	
	$remote = '';
	
	if(!($remote = @fopen($avatar_url, 'r')) )
	{// Не удалось достать аватар из uCoz - FORBIDDEN - нам не отдают - теперь придется воткнуть URL
		// ВОЗМОЖНО более правильно вообще не оставлять пользователю аватар!!!
		echo "ОШИБКА - загрузки аватара $avatar_url <br/>";
	/*	удаленные аватары по умолчанию запрещены
		$user_sql['user_avatar'] = $avatar_url;
		$user_sql['user_avatar_type'] = AVATAR_REMOTE;
		$user_sql['user_avatar_width'] = $config['avatar_max_width']; // FIXME! Но какого размера? 
		$user_sql['user_avatar_height']	= $config['avatar_max_width'];// FIXME! Но какого размера?  
	*/
		return;
	}

	$local = '';
	
	if(!($local = @fopen($ava_full_path, 'w')) )
	{// Проблемы при сохранени - вот странно 
		fclose($remote);
		echo "ОШИБКА - сохранения аватара $ava_full_path <br/>";
	/*	удаленные аватары по умолчанию запрещены
		$user_sql['user_avatar'] = $avatar_url;
		$user_sql['user_avatar_type'] = AVATAR_REMOTE;
		$user_sql['user_avatar_width'] = $config['avatar_max_width'];
		$user_sql['user_avatar_height']	= $config['avatar_max_width'];
		if(($image_data = @getimagesize($avatar_url)) !== false)
		{
			$user_sql['user_avatar_width'] = $image_data[0];
			$user_sql['user_avatar_height']	= $image_data[1];
		}
	*/
		return;
	}

	// Копируем из uCoz
	while($data = fread($remote, 4096) )
	{
		fwrite($local, $data);
	}

	fclose($local);
	fclose($remote);
	
	$user_sql['user_avatar'] = $ava_filenmae_sql; // замена $ava_filenmae
	$user_sql['user_avatar_type'] = AVATAR_UPLOAD;
	//$user_sql['user_avatar_width'] = $config['avatar_max_width'];  - перенесено в postprocess_avatar()
	//$user_sql['user_avatar_height']	= $config['avatar_max_width']; - перенесено в postprocess_avatar()
	postprocess_avatar($ava_full_path, $user_sql);
}

// Подгонка размера аватара  (было)
// ЗДЕСЬ ТОЛЬКо УМЕНЬШЕНИЕ РАЗМЕРА БОЛЬШИХ АВАТАР (было)
// Запись размеров аватара пользователя в базу неизменными и определение min,max размеров аватар (стало)
function postprocess_avatar($ava_full_path, &$user_sql)
{
	global $config, $phpbb_root_path, $max_avatar_size, $max_avatar_width, $max_avatar_height, $min_avatar_width, $min_avatar_height;

	if(($image_data = @getimagesize($ava_full_path)) !== false)
	{
			$user_sql['user_avatar_width'] = $image_data[0];
			$user_sql['user_avatar_height']	= $image_data[1];
			$avatar_size = filesize($ava_full_path);
			if ($avatar_size > $max_avatar_size) $max_avatar_size = $avatar_size;
			if ($image_data[0] > $max_avatar_width) $max_avatar_width = $image_data[0];
			if ($image_data[0] < $min_avatar_width) $min_avatar_width = $image_data[0];
			if ($image_data[1] > $max_avatar_height) $max_avatar_height = $image_data[1];
			if ($image_data[1] < $min_avatar_height) $min_avatar_height = $image_data[1];	
	}
	return;
	/*	if($image_data[0] > $config['avatar_max_width'] || $image_data[1] > $config['avatar_max_height'])
		{/// Слишком большой (НЕ ПРОВЕРЯЕТСЯ ОГРАНИЧЕНИЕ НА МИНИМАЛЬНЫЙ РАЗМЕР!!!)
			$big;
			switch($image_data[2])
			{
				case 1: //GIF
					$big = @imagecreatefromgif($ava_full_path);
					break;
				case 2: //JPG
					$big = @imagecreatefromjpeg($ava_full_path);
					break;
				case 3: //PNG
					$big = @imagecreatefrompng($ava_full_path);
					break;
				default:
					return; 
			}
			if($big === false)
				return;
			$small = @imagecreatetruecolor($config['avatar_max_width'], $config['avatar_max_height']);
			if($small === false)
			{// Очень странно! 
				@imagedestroy($big);
				return;
			}
			@imagecolortransparent($small); 
			@imagecopyresized($small, $big, 0, 0, 0, 0, $config['avatar_max_width'], $config['avatar_max_height'], $image_data[0], $image_data[1]);
			@imagedestroy($big);
			
			switch($image_data[2])
			{/// ТИХОЕ ИГНОРИРОВАНИЕ ОШИБКИ ПРИ СОХРАНЕНИИ!!! 
				case 1: //GIF
					@imagegif($small, $ava_full_path);
					break;
				case 2: //JPG
					@imagejpeg($small, $ava_full_path);
					break;
				case 3: //PNG
					@imagepng($small, $ava_full_path);
					break;
			}
			@imagedestroy($small);
		}    
		else
		{// Не удалось сжать - придется указать реальные размеры
			$user_sql['user_avatar_width'] = $image_data[0];
			$user_sql['user_avatar_height']	= $image_data[1];
		} 
	*/
}

include_once($phpbb_root_path . 'includes/functions_messenger.' . $phpEx);


/* Предопределенные группы пользователей: 
 в PHPbb
 1 - GUESTS
 2 - REGISTERED
 3 - REGISTERED_COPPA
 4 - GLOBAL_MODERATORS
 5 - ADMINISTRATORS
 6 - BOTS
 7 - NEWLY_REGISTERED
 в ucoz
 1 - NEWLY_REGISTERED (Пользователи)
 2 - REGISTERED (Проверенные)
 3 - MODERATORS (Модераторы)
 4 - ADMINISTRATORS (Администраторы)
 251 - ДРУЗЬЯ (что с ними делать???)
 255 - BLOCKED (заблокированные 
 - их не переносим, т.к. при использовании Unet - удалять нельзя и это единственный способ избавиться от них)
 */
// Карта соответствия групп пользователей ucoz -> phpbb
/* КАК НАРАЩИВАТь ЭТУ КАРТУ!!! 
 Создайте средствами PHPbb необходимые группы (какие были в ucoz)
 отыщите их идентификаторы и добавьте в карту строки вида
 {ID_группы_из_ucoz} => array( {ID_созданной_группы_PHPbb}, 2 ),
 для каждой добавленной группы

 ИЛИ измените константу USE_GROUP_2_FOR_UNKNOWN_GROUPS в true (стр 464)
 чтобы все пользователи из таких групп отправились в стандартную группу 
 зарегистрированных пользователей PHPbb
*/
define ("UCOZ_GROUP_BLOCKED", 255);
$groups_map = array(
	1 => array( 7, 2 ),
	2 => array( 2 ),
	3 => array( 4, 2 ),
	4 => array( 5, 4, 2 ),
	251 => array( 2 ),
); 

// Использовать ли PHPbb группу зарегистрированные пользователи 
// для групп ucoz не перечисленных в карте соответствия групп
// Если не использовать и такая группа будет обнаружена то скрипт остановится
define ("USE_GROUP_2_FOR_UNKNOWN_GROUPS", false);


/// Получить первичную группу PHPbb для группы ucoz
/// возвращает -1 для заблокированных пользователей (их не стоит переносить)
/// останавливает скрипт если не понятно что делать с такой группой
function ucoz_get_primary_group($ucoz_group)
{
	global $groups_map;

	if($ucoz_group == UCOZ_GROUP_BLOCKED)
		return -1;
	
	if(!array_key_exists($ucoz_group, $groups_map) )
	{
		echo "Найдена неопределенная группа $ucoz_group в дампе UCOZ!!!<br/>"; 
	
		if(USE_GROUP_2_FOR_UNKNOWN_GROUPS)
			return 2;
		else		
			exit("РАЗБЕРИТЕСЬ С ГРУППАМИ - ucoz2bb.php:439"); 
	}
	return $groups_map[$ucoz_group][0]; 
}

/// Добавить пользователя в группу(ы)
function ucoz_add_user_to_group($user_id, $ucoz_group)
{
	global $db, $groups_map;
	
	if(!array_key_exists($ucoz_group, $groups_map) )
	{
		if(USE_GROUP_2_FOR_UNKNOWN_GROUPS)
			$ucoz_group = 2;
		else		
			exit("РАЗБЕРИТЕСЬ С ГРУППАМИ - ucoz2bb.php:438"); 
	}
		
	$is_default_group = true; /// Первая группа в массиве - основная группа
	foreach($groups_map[$ucoz_group] as $key => $group_id)
	{
		$user_group = array(
						'group_id'		=>$group_id,
						'user_id'		=>$user_id,
						'group_leader'	=>0,
						'user_pending'	=>0,
						);
		$sql = 'INSERT INTO ' . USER_GROUP_TABLE . ' ' . $db->sql_build_array('INSERT', $user_group);
		$db->sql_query($sql);
		if($is_default_group)
		{
			group_set_user_default($group_id, array($user_id), false);
			$is_default_group = false;
		}
	}
}


function ucoz_import_users($ucoz_dump_users, $ucoz_dump_ugen)
{
	global $db, $config, $groups_map, $ucoz_uid_shift, $ucoz2PHPbb_UID_map;
	echo 'Импорт пользователей...<br/>';
	my_flush();
	
	$i=0;
	$f_h_users = fopen($ucoz_dump_users, "r");
	while (!feof($f_h_users))
	{
		$l_user = fgets($f_h_users);
		if (!empty($l_user))
		{
			$i++;
			if(!($i % 50))
			{
				echo "&nbsp; $i пользователей импортировано...<br/>";
				my_flush();
			}
			$r_user = explode('|',$l_user);
			$f_h_ugen = fopen($ucoz_dump_ugen, "r");
			while (!feof($f_h_ugen))
			{// Не оптимально но более надежно
				$l_ugen = fgets($f_h_ugen);
				if (!empty($l_ugen) )
				{
					$r_ugen = explode('|',$l_ugen);
					if ($r_user[0]===$r_ugen[1])
					{
						$primary_group = ucoz_get_primary_group($r_ugen[2]); 
						if($primary_group == -1)
						{
							echo 'Пользователь ' . $r_user[0] . ' ЗАБЛОКИРОВАН!</br>';
							break;
						}
					
						// А нет ли уже зарегистрированного в PHPbb пользователя с таким же логином	
						$_result = $db->sql_query('SELECT user_id FROM ' . USERS_TABLE .  ' WHERE username_clean = \'' . _E(utf8_clean_string($r_user[0])). '\' ;');						
						$PHPbb_UID_Probably = $db->sql_fetchfield('user_id');
						$db->sql_freeresult($_result);
						if($PHPbb_UID_Probably !== false)
						{// Есть! - тогда не будем создавать нового пользователя а запишим соотношение UIDов в карту
							$ucoz2PHPbb_UID_map[$r_ugen[0] ] = $PHPbb_UID_Probably;
							--$ucoz_uid_shift;
							echo 'Пользователь ' . $r_user[0] . ' уже зарегистрирован в PHPbb!</br>';
							break;
						}
						// Так же проверим адрес почты использованный при регистрации
						if(!$r_user[7])
						{/// Вообще без мыла???? 
							break;
						}
						$_result = $db->sql_query('SELECT user_id, username FROM ' . USERS_TABLE .  ' WHERE user_email = \'' . _E($r_user[7]) . '\' ;');						
						$PHPbb_user_row = $db->sql_fetchrow($_result);
						$db->sql_freeresult($_result);
						if($PHPbb_user_row && array_key_exists('user_id', $PHPbb_user_row) )
						{// Есть! - тогда не будем создавать нового пользователя а запишим соотношение UIDов в карту
							$ucoz2PHPbb_UID_map[$r_ugen[0] ] = $PHPbb_user_row['user_id'];
							--$ucoz_uid_shift;
							echo 'У пользователя ' . $r_user[0] . ' такой же e-mail ' . $r_user[7] . ' как и у уже зарегистрированного ' . $PHPbb_user_row['username'] . '</br>';
							break;
						}
						
						// Создаем UID с компенсацией пропусков.
						$user_id = $ucoz_uid_shift + count($ucoz2PHPbb_UID_map) + 1;
						$ucoz2PHPbb_UID_map[$r_ugen[0] ] = $user_id;
						$user = array(
								    'user_id'					=> $user_id,
								    'username'            	  	=> _E($r_user[0]),
								    'user_password'   			=> _E($r_user[2]),
									'user_pass_convert'			=> 1,
								    'user_email'            	=> _E($r_user[7]),
								    'user_email_hash'			=> phpbb_email_hash($r_user[7]),
								    'username_clean'			=> _E(utf8_clean_string($r_user[0])),
								    'group_id'              	=> $primary_group,
									//-------------------------------------------------------------
									'user_permissions'	=> '',
									'user_timezone'		=> $config['board_timezone'],
									'user_dateformat'	=> $config['default_dateformat'],
									'user_lang'			=> $config['default_lang'],
									'user_style'		=> (int) $config['default_style'],
									'user_actkey'		=> '',
									'user_ip'			=> _E($r_user[16]),
									'user_regdate'		=> $r_user[15],
									'user_passchg'		=> time(),
									'user_options'		=> 230271,

									'user_new'			=> 1, //? 

									'user_inactive_reason'	=> 0,
									'user_inactive_time'	=> 0,
									'user_lastmark'			=> time(),
									'user_lastvisit'		=> $r_ugen[18],
									'user_lastpost_time'	=> 0,
									'user_lastpage'			=> '',
									'user_posts'			=> (int)$r_ugen[9],
									'user_dst'				=> (int)$config['board_dst'],
									'user_colour'			=> '',
									'user_from'				=> _E($r_user[12]),
									'user_occ'				=> '',
									'user_interests'		=> '',
									'user_avatar'			=> '',
									'user_avatar_type'		=> 0,
									'user_avatar_width'		=> 0,
									'user_avatar_height'	=> 0,
									'user_new_privmsg'		=> 0,
									'user_unread_privmsg'	=> 0,
									'user_last_privmsg'		=> 0,
									'user_message_rules'	=> 0,
									'user_full_folder'		=> PRIVMSGS_NO_BOX,
									'user_emailtime'		=> 0,

									'user_notify'			=> 0,
									'user_notify_pm'		=> 1,
									'user_notify_type'		=> 0,
									'user_allow_pm'			=> 1,
									'user_allow_viewonline'	=> 1,
									'user_allow_viewemail'	=> 1,
									'user_allow_massemail'	=> 1,

									'user_sig'					=> _E($r_user[13]),
									'user_sig_bbcode_uid'		=> '',
									'user_sig_bbcode_bitfield'	=> '',

//									'user_reputation'			=>0,//(int)$data_unet[7],

									'user_form_salt'			=> unique_id(),
									/// ADD
									'user_birthday'				=> date('j-n-Y', strtotime($r_user[22]) ),
									'user_website'				=> _E($r_user[8]),
									'user_icq'					=> _E($r_user[9]),
									'user_aim'					=> _E($r_user[18]),
									'user_msnm'					=> _E($r_user[19]),
									'user_yim'					=> _E($r_user[20]),
								);
						if($r_user[3])/// У пользователя есть Аватар
							ucoz_add_avatar($r_user[3], $user_id, $user);
						$sql = 'INSERT INTO ' . USERS_TABLE . ' ' . $db->sql_build_array('INSERT', $user);
						$db->sql_query($sql);
						ucoz_add_user_to_group($user_id, (int)$r_ugen[2]);
						ucoz_add_user_profile($user_id, $r_user, $r_ugen);
						break;
					}
				}
			}
		}
	}
	fclose($f_h_users);
	fclose($f_h_ugen);
	echo "&nbsp; (ГОТОВО). $i пользователей импортировано. <br/>";
}

/* NEEDED DATA
	'forum_last_post_id'		=> 0,
	'forum_last_poster_id'		=> 0,
	'forum_last_post_subject'	=> '',
	'forum_last_post_time'		=> 0,
	'forum_last_poster_name'	=> '',
*/
$forums_last_posts = array( );

function ucoz_import_forums($ucoz_dump)
{
	global $db, $config, $ucoz2PHPbb_UID_map, $ucoz_fid_shift;
	
	echo 'Импорт форумов...<br/>';
	my_flush();
	
 	$file_handle = fopen($ucoz_dump, "r");
 	$i=0;
	while (!feof($file_handle))
	{
		$line = fgets($file_handle);
		if (!empty($line))
		{
			$i++;
			if(!($i % 100))
				echo "&nbsp; $i форумов импортировано...<br/>";
			$data = explode('|',$line);
//---------------Категории---------------------------
			if ($data[1]==0)
			{
				$sql_ary = array(
									'forum_id'		=> $data[0] + $ucoz_fid_shift,
									'forum_name'	=> _E($data[5]),
									'parent_id'		=> 0, // Категории всегда корневые, хотя это не всегда так;)
									'forum_parents'	=> '',
									'forum_desc'	=> '',
									'forum_type'	=> FORUM_CAT,
									'forum_status'	=> ITEM_UNLOCKED,
									'forum_rules'	=> '',
								);
				$sql = 'SELECT MAX(right_id) AS right_id
						FROM ' . FORUMS_TABLE;
				$_result = $db->sql_query($sql);
				$cat_row = $db->sql_fetchrow($_result);
				$db->sql_freeresult($_result);

				$sql_ary['left_id'] = $cat_row['right_id'] + 1;
				$sql_ary['right_id'] = $cat_row['right_id'] + 2;

				$sql = 'INSERT INTO ' . FORUMS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
				$db->sql_query($sql);
				add_acl_to_forum($data[0] + $ucoz_fid_shift, false);
			}
//-----------------Форумы------------------------------
			if ($data[1]!=0)
			{
				$sql_ary = array(
					'forum_id'			=> $data[0] + $ucoz_fid_shift,
					'forum_name'		=> _E($data[5]),
					'parent_id'			=> $data[1] + $ucoz_fid_shift,
					'forum_parents'		=> '',
					'forum_desc'		=> _E($data[6]),
					'forum_type'		=> FORUM_POST,
					'forum_status'		=> ITEM_UNLOCKED,
					//'enable_prune'	=> $row['prune_enable'],
					//'prune_next'		=> null_to_zero($row['prune_next']),
					//'prune_days'		=> null_to_zero($row['prune_days']),
					//'prune_viewed'	=> 0,
					//'prune_freq'		=> null_to_zero($row['prune_freq']),
					//'forum_flags'		=> phpbb_forum_flags(),

					// Default values
					'forum_desc_bitfield'		=> '',
					'forum_desc_options'		=> 7,
					'forum_desc_uid'			=> '',
					'forum_link'				=> '',
					'forum_password'			=> '',
					'forum_style'				=> 0,
					'forum_image'				=> '',
					'forum_rules'				=> '',
					'forum_rules_link'			=> '',
					'forum_rules_bitfield'		=> '',
					'forum_rules_options'		=> 7,
					'forum_rules_uid'			=> '',
					'forum_topics_per_page'		=> 0,
					'forum_posts'				=> $data[10],
					'forum_topics'				=> $data[9],
					'forum_topics_real'			=> $data[9],
					'forum_last_post_id'		=> 0,
					'forum_last_poster_id'		=> 0,
					'forum_last_post_subject'	=> '',
					'forum_last_post_time'		=> 0,
					'forum_last_poster_name'	=> '',
					'forum_last_poster_colour'	=> '',
					'display_on_index'			=> 1,
					'enable_indexing'			=> 1,
					'enable_icons'				=> 0,
				);


				$sql = 'SELECT left_id, right_id
							FROM ' . FORUMS_TABLE . '
							WHERE forum_id = ' . ($data[1] + $ucoz_fid_shift);
				$_result = $db->sql_query($sql);
				$cat_row = $db->sql_fetchrow($_result);


				$sql = 'UPDATE ' . FORUMS_TABLE . '
							SET left_id = left_id + 2, right_id = right_id + 2
							WHERE left_id > ' . $cat_row['right_id'];
				$db->sql_query($sql);

				$sql = 'UPDATE ' . FORUMS_TABLE . '
							SET right_id = right_id + 2
							WHERE ' . $cat_row['left_id'] . ' BETWEEN left_id AND right_id';
				$db->sql_query($sql);

				$sql_ary['left_id'] = $cat_row['right_id'];
				$sql_ary['right_id'] = $cat_row['right_id'] + 1;

				$sql = 'INSERT INTO ' . FORUMS_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
				$db->sql_query($sql);
				add_acl_to_forum($data[0] + $ucoz_fid_shift, true);
			}
		}
	}
	fclose($file_handle);
	echo "&nbsp; (ГОТОВО). $i форумов импортировано. <br/>";
}

$topics_with_pools = array( );

/* NEEDED DATA
	'topic_last_post_id'		=> 0,//$data[4] + $ucoz_pid_shift,
	'topic_last_poster_id'		=> 0,
*/
$topics_last_posts = array( );

function ucoz_import_topic($ucoz_dump)
{
	global $db, $config, $ucoz_fid_shift, $ucoz_tid_shift, $ucoz_pid_shift, $topics_with_pools;
	
	echo 'Импорт тем...<br/>';
	my_flush();
	
	$file_handle = fopen($ucoz_dump, "r");
	$i=0;
	while (!feof($file_handle))
	{
		$line = fgets($file_handle);
		if (!empty($line))
		{
			$i++;
			if(!($i % 100))
			{
				echo "&nbsp; $i тем импортировано...<br/>";
				my_flush();				
			}
            $data = explode('|',$line);
			$data_topic = array(
								'forum_id'           		=> $data[1] + $ucoz_fid_shift,    // The forum ID in which the post will be placed. (int)
								'topic_id'           		=> $data[0] + $ucoz_tid_shift,    // Post a new topic or in an existing one? Set to 0 to create a new one, if not, specify your topic ID here instead.
								'icon_id'            		=> false,    // The Icon ID in which the post will be displayed with on the viewforum, set to false for icon_id. (int)
								'topic_type'				=> $data[3], //Type=1 для прикрепленных тем и 0 для обычных
								'topic_title'				=> _E($data[8]),
								'topic_poster'				=> get_PHPbb_uid($data[15], true),
								'topic_time'				=> 0,
								'topic_views'				=> $data[7],
								'topic_first_post_id'		=> 0,
								'topic_first_poster_name'	=> $data[10],
								'topic_first_poster_colour'	=> "AA0000",
								'topic_last_post_id'		=> 0,//$data[4] + $ucoz_pid_shift,
								'topic_last_poster_id'		=> 0,
								'topic_last_poster_name'	=> _E($data[12]),
								'topic_last_poster_colour'	=> "AA0000",
								'topic_last_post_subject'	=> _E($data[9]),
								'topic_last_post_time'		=> $data[4],
								'topic_replies'				=> $data[6],
								'topic_replies_real'		=> $data[6],
								);
			$sql = 'INSERT INTO ' . TOPICS_TABLE . ' ' . $db->sql_build_array('INSERT', $data_topic);
			$db->sql_query($sql);
			$data_topic_posted = array(
							 			'user_id'		=> get_PHPbb_uid($data[15], true),
							 			'topic_id'	    => $data[0] + $ucoz_tid_shift,
							 			'topic_posted'  => 1,
										);
			$sql = 'INSERT INTO ' . TOPICS_POSTED_TABLE . ' ' . $db->sql_build_array('INSERT', $data_topic_posted);
			$db->sql_query($sql);
			
			if($data[2] == 1) // В этой теме есть опрос - заполним позже - сейчас лишь пометим этот топик
				$topics_with_pools[$data[0] + $ucoz_tid_shift] = 'poll';
		}
	}
	fclose($file_handle);
	echo "&nbsp; (ГОТОВО). $i тем импортировано. <br/>";
}

function ucoz_import_messages($ucoz_dump)
{
	global $db, $config, $ucoz_fid_shift, $ucoz_tid_shift, $ucoz_pid_shift, $topics_with_pools, $topics_last_posts, $forums_last_posts;
	
	echo 'Импорт сообщений...<br/>';
	my_flush();
	
	$file_handle = fopen($ucoz_dump, "r");
	$i=0;
	while (!feof($file_handle))
	{
		$line = fgets($file_handle);
		if (!empty($line))
		{
			$i++;
			if(!($i % 300))
			{
				echo "&nbsp; $i сообщений импортировано...<br/>";
				my_flush();
			}
            $data = explode('|',$line);
            if ($data[3]!=0)
            {// Это первый пост в теме - дозаполним тему
            	$data_topic = array(
            						'topic_time'				=> $data[2],
            						'topic_first_post_id'		=> $data[0],
            						);
				if(array_key_exists($data[1] + $ucoz_tid_shift, $topics_with_pools))
				{// В этом посту должна быть информация о голосовалке
				 /// TODO:  както все не очень получается - для нормального функционирования
				 /// необходимо заполнить табличку с голосами, а в УКОЗе нет днных о том кто голосовал
					$poll_data = explode('`', $data[14]);
					if($poll_data[0] != '')
					{
						$poll_counter = 1;
						for(;$poll_counter <= 10; ++$poll_counter)
						{
							if($poll_data[$poll_counter] == '')
								break;
							$poll_record = array(
												 'poll_option_id'		=> $poll_counter,
												 'topic_id'				=> $data[1] + $ucoz_tid_shift,
												 'poll_option_text'		=> _E($poll_data[$poll_counter]),
												 'poll_option_total'	=> $poll_data[10 + $poll_counter],
												 );
				            $sql = 'INSERT INTO ' . POLL_OPTIONS_TABLE . ' ' . $db->sql_build_array('INSERT', $poll_record);
							$db->sql_query($sql);
						}
						$poll_length = $poll_data[24] - $data[2];
						if($poll_length < 0)
							$poll_length = 0;
						$data_topic['poll_title'] = _E($poll_data[0]);
						$data_topic['poll_start'] = $data[2];
						$data_topic['poll_max_options'] = 1;
						if($poll_data[23] == 1)
							$data_topic['poll_max_options'] = $poll_counter - 1;
						$data_topic['poll_length'] = $poll_length;
					}
					
				}
            	$sql = 'UPDATE ' . TOPICS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $data_topic).' WHERE topic_id='.($data[1] + $ucoz_tid_shift);
				$db->sql_query($sql);
            }
            $sql = 'SELECT  topic_id, forum_id, topic_title
			        FROM ' . TOPICS_TABLE .'
        			WHERE topic_id = '.($data[1] + $ucoz_tid_shift);
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$forum_id = $row['forum_id'];
			$subject = $row['topic_title'];

            $data_post = array(
            	                'post_id'			=>$data[0] + $ucoz_pid_shift,
            	                'topic_id'          =>$data[1] + $ucoz_tid_shift,
            	                'forum_id'          =>$forum_id,
            	                'poster_id'         =>get_PHPbb_uid($data[15], false),
            	                'icon_id'           =>0,
            	                'poster_ip'         =>$data[12],
            	                'post_time'         =>$data[2],
            	                'post_approved'     =>1,
            	                'post_reported'     =>0,
            	                'enable_bbcode'     =>1,
            	                'enable_smilies'    =>1,
            	                'enable_magic_url'  =>1,
            	                'enable_sig'        =>1,
            	                'post_username'     =>'',//$data[6], << Почему то в родных сообщениях ПХПбб оно пустое
            	                'post_subject'      =>$subject,
            	                'post_text'         =>convert_post($data[4]),
            	                'post_checksum'     =>md5($data[4]),
            	                'post_attachment'   =>0,
            	                'bbcode_bitfield'   =>'',
            	                'bbcode_uid'        =>'',//make_uid($data[2]),
            	                'post_postcount'    =>1,
            	                'post_edit_time'    =>0,//$data[9],
            	                'post_edit_reason'  =>'',
            	                'post_edit_user'    =>0,//get_PHPbb_uid($data[8], false),
            	                'post_edit_count'   =>0,
            	                'post_edit_locked'  =>0,
 /*           	                'post_deleted_from' =>0,
            	                'post_deleted_user' =>0,
            	                'post_deleted_time' =>0,
            	                'post_deleted_reason'=>'',*/
            					);
            // Редактирование постов
            /*if($data[8] !== '')
            {
                'post_edit_time'    =>$data[9],
                'post_edit_reason'  =>'',
                'post_edit_user'    =>2,//get_PHPbb_uid($data[8], false),
                // Тут самая засада - в УКОЗе здесь логин пользователя, а нужен UID
                // нужна переделка карты пользователей
                'post_edit_count'   =>1,
            }*/
            $sql = 'INSERT INTO ' . POSTS_TABLE . ' ' . $db->sql_build_array('INSERT', $data_post);
			$db->sql_query($sql);
			
			// Подготавливаем данные для финализации
			// Тем
			$topics_last_posts[$data[1] + $ucoz_tid_shift]['topic_last_post_id'] = $data[0] + $ucoz_pid_shift;
			$topics_last_posts[$data[1] + $ucoz_tid_shift]['topic_last_poster_id'] = get_PHPbb_uid($data[15], false);
			// Форумов
			$forums_last_posts[$forum_id]['forum_last_post_id'] = $data[0] + $ucoz_pid_shift;
			$forums_last_posts[$forum_id]['forum_last_poster_id'] = get_PHPbb_uid($data[15], false);
			$forums_last_posts[$forum_id]['forum_last_post_time'] = $data[2];
			$forums_last_posts[$forum_id]['forum_last_poster_name'] = _E($data[6]);
			$forums_last_posts[$forum_id]['forum_last_post_subject'] = $subject;
  		}
  	}
  	fclose($file_handle);
	echo "&nbsp; (ГОТОВО). $i сообщений импортировано. <br/>";
}

function finalize_import()
{
	global $db, $topics_last_posts, $forums_last_posts;
	
	echo 'Финализация после импорта форума...<br/>';
	my_flush();

	// Финализируем
	// Тем
	echo 'Обновление тем... <br/>';
	my_flush();
	$i = 0;
	foreach($topics_last_posts as $topic => $data_topic)
	{
    	$sql = 'UPDATE ' . TOPICS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $data_topic).' WHERE topic_id = ' . $topic . ';';
		$db->sql_query($sql);
		
		$i++;
		if(!($i % 100))
		{
			echo "&nbsp; $i тем обновлено...<br/>";
			my_flush();				
		}
	}
	echo "&nbsp; (ГОТОВО).<br/>";
	my_flush();	
	
	// Форумов
	echo 'Обновление форумов... ';
	my_flush();
	foreach($forums_last_posts as $forum => $data_forum)
	{
    	$sql = 'UPDATE ' . FORUMS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $data_forum).' WHERE forum_id = ' . $forum . ';';
		$db->sql_query($sql);
	}
	echo "&nbsp; (ГОТОВО).<br/>";
	my_flush();
}

function check_ucoz_dump()
{
	echo 'Проверка полноты дампа...	';
	if(!file_exists("users.txt") ||
		!file_exists("ugen.txt") ||
		!file_exists("fr_fr.txt") ||
		!file_exists("forum.txt") ||
		!file_exists("forump.txt") )
	{
		echo 'НЕ НАЙДЕНЫ ОСНОВНЫЕ ФАЙЛЫ ДАМПА ФОРУМА! <br/>';
		echo 'ПРОВЕРЬТЕ НАХОДЯТСЯ ЛИ ФЙАЛЫ users.txt, ugen.txt, fr_fr.txt, 
		forum.txt и forump.txt В КОРНЕВОМ КАТАЛОГЕ PHPbb (по соседству с этим скриптом). <br/>';
		return false;
	}
	if(!is_dir(DUMP_AVATARS_PATH) )
	{
		echo '&nbsp; (ГОТОВО), но не доступен каталог аватаров. <br/>';
		return true;
	}
	echo '&nbsp; (ГОТОВО). <br/>';
	return true;
}

if(check_ucoz_dump() )
{
	my_flush();
	analyze_phpbb();
	ucoz_import_users("users.txt","ugen.txt");
	echo 'Пользователей в карте пользователей: ' . (count($ucoz2PHPbb_UID_map) + 1) . '<br/>';
	
	ucoz_import_forums("fr_fr.txt");
	ucoz_import_topic("forum.txt");
	ucoz_import_messages("forump.txt");
	finalize_import();
}

?>
</P>
<H2>
ПОЗДРАВЛЯЮ. Импорт дампа форума ucoz завершен!
 
</H2>
<?php
echo "<h3>Измените настройки аватар:</h3>
	Максимальный размер файла аватары, не меньше: $max_avatar_size<br/>
	Минимальные размеры аватар, не больше: $min_avatar_width x $min_avatar_height<br/>
	Максимальные размеры аватар, не меньше: $max_avatar_width x $max_avatar_height<br/>";
if(is_dir(DUMP_AVATARS_PATH) )
{
	echo '<h3>Не забудьте удалить каталог с аватарами!</h3>';
}
?>
</BODY>
</HTML>